jQuery(function($){
    /** Update preview **/
    
    //Links to include
    var links={
        "facebook" : "fb",
        "twitter" : "t",
        "gplus" : "g",
        "linkedin" : "l",
        "pinterest" : "p",
        "reddit" : "r",
        "delicious" : "d"
    };
    $.each(links, function(name, l){
        $('#links-'+name).click(function(e){
            if ($(this).prop("checked")) {
                $('#xsss-preview a.xsss-'+l).css('display','');
            }
            else{
                $('#xsss-preview a.xsss-'+l).hide();
            }
        });
        $('#links-'+name).each(function(e){
            if (!$(this).prop("checked")) {
                $('#xsss-preview a.xsss-'+l).hide();
            }
        });
    });
        
    //Position - before or after content
    (function(){
        var pos=['before', 'after'];
        var before=$('#xsss-buttons-before');
        var after=$('#xsss-buttons-after');
        if (after.length && !before.length) {
            before = after.clone(true,true);
            before.attr('id', 'xsss-buttons-before');
            before.css({"display":"none"});
            before.insertBefore('#xsss-preview p');
        }
        else if (before.length && !after.length) {
            after = before.clone(true,true);
            after.attr('id', 'xsss-buttons-after');
            after.css({"display":"none"});
            after.insertAfter('#xsss-preview p');
        }
        else if (!before.length && !after.length){
            return;
        }
        
        $('#pos-before').click(function(e){
            if ($(this).prop("checked")) {
                before.show();
            }
            else{
                before.hide();
            }
        });
        $('#pos-after').click(function(e){
            if ($(this).prop("checked")) {
                after.show();
            }
            else{
                after.hide();
            }
        });
    })();
        
    //Add color picker for preview background
    var chooseBGColor = $('<div>'+xsssL10n.previewBGcolor+'</div>').css({"clear":"both"})
    $('<span id="colorPickerInput" ></span>').appendTo(chooseBGColor).wpColorPicker({"change":function(e, ui){
        $('#xsss-preview').css({"background-color" : ui.color.toString()});
    }});
    if ($.support.iris) {
        chooseBGColor.insertAfter('#xsss-preview');
    }
    else{
        chooseBGColor=null;
    }
    
    //Title
    $('#title').keyup(function(e){
        $('#xsss-preview h4').text(this.value);
    });
    
    //remove the stylesheet and add our stylesheet as inline CSS instead so we can update it using js
    var $cssPreview=$('<style type="text/css" id="css-preview">'+$('#css').text()+'</style>'),
    $currentCSS=$('#xoogu-simple-social-sharing-css');
    if($currentCSS.length){
        $currentCSS.replaceWith($cssPreview);
    }else{
        $('head').append($cssPreview);
    }
    
    /*## End update preview ##*/
    
    /*** css preset select loader ***/
        
    //listen for preset change
    $('#css-preset').change(function(e){
        //get the size, bitDepth, and titlePos values from the selected preset value
        var vals = this.value.split(' ');
        if (vals.length<3) {
            return;
        }
        //use these to generate the CSS preset css
        var css = generateCSSpreset(parseInt(vals[0]),parseInt(vals[1]),!!parseInt(vals[2]));
        //update the textarea with the css
        $('#css').text(css);
        //update our inline style with the css in order to update the preview
        $('#css-preview').text(css);
    });
        
    /**
     *Generate CSS for the plugin to use
     *@param int size The size in pixels of the icons (16, 32, or 64)
     *@param int bitDepth Use PNG8 or PNG32 image
     *@param bool titlePos Whether the title should be positioned above (false) or to the left (true) of the icons
     */
    function generateCSSpreset(size, bitDepth, titlePos){
        //defaults
        size=size||32, bitDepth=bitDepth||32, titlePos=titlePos||false;
        var css=
'#xsss-buttons-before a, #xsss-buttons-after a{'+"\n"+
'	width: '+size+'px;'+"\n"+
'	height: '+size+'px;'+"\n"+
'	background-image: url("'+document.getElementById('pluginURL').value+'/imgs/social-icons-PNG'+bitDepth+'-'+size+'px.png");'+"\n"+
'	display: inline-block;'+"\n"+
'	text-indent: 100%;'+"\n"+
'	white-space: nowrap;'+"\n"+
'	overflow: hidden;'+"\n"+
'	vertical-align: middle;'+"\n"+
'	/*'+xsssL10n.ie7comment+'*/'+"\n"+
'	*text-indent: 0;'+"\n"+
'	font-size:0;'+"\n"+
'	line-height: 0;'+"\n"+
'}'+"\n"+
'#xsss-buttons-before a:hover, #xsss-buttons-after a:hover{'+"\n"+
'	-moz-filter: brightness(1.1);'+"\n"+
'	-webkit-filter: brightness(1.1);'+"\n"+
'	-ms-filter: brightness(1.1);'+"\n"+
'	filter: brightness(1.1);'+"\n"+
'}'+"\n"+
'.xsss-fb{'+"\n"+
'	background-position: -'+(size*2)+'px 0;'+"\n"+
'}'+"\n"+
'.xsss-t{'+"\n"+
'	background-position: '+(size*4)+'px 0;'+"\n"+
'}'+"\n"+
'.xsss-g{'+"\n"+
'	background-position: '+(size*3)+'px 0;'+"\n"+
'}'+"\n"+
'.xsss-l{'+"\n"+
'	background-position: -'+size+'px 0;'+"\n"+
'}'+"\n"+
'.xsss-r{'+"\n"+
'	background-position: '+(size*2)+'px 0;'+"\n"+
'}'+"\n"+
'.xsss-d{'+"\n"+
'	background-position: '+size+'px 0;'+"\n"+
'}';
        if(titlePos){
            css += "\n"+
'h4.xsss-title{'+"\n"+
'	display: inline-block;'+"\n"+
'	margin: 0 10px 0 0;'+"\n"+
'	/*'+xsssL10n.ie7comment+'*/'+"\n"+
'	*display: inline;'+"\n"+
'}';
		}else{
			css += "\n"+
'h4.xsss-title{'+"\n"+
'	margin: 1em 0 0.5em 0'+"\n"+
'}';
		}
		return css;
	}
    /*## End css preset select loader ##*/
});